#include "ObjectHandler.h"

void ObjectHandler::updateObjects(float t, float dt, uint32_t currentImage, Camera& camera) {
	for (Object* obj : m_objects) {
		obj->update(t, dt, currentImage, camera);
	}
};

void ObjectHandler::updateObjectsForCubemapDraw(float t, float dt, uint32_t currentImage, glm::mat4 viewMat, glm::mat4 projMat) {
	for (Object* obj : m_objects) {
		obj->updateForCubemapDraw(t, dt, currentImage, viewMat, projMat);
	}
};

void ObjectHandler::addObject(Object* object) {
	m_objects.push_back(object);
};

void ObjectHandler::removeObject(Object* object) {
	// TODO: implement remove function (needs == operator)
	//m_objects.erase(std::remove(m_objects.begin(), m_objects.end(), object), m_objects.end());
};

void ObjectHandler::cleanup() {
	for (Object* obj : m_objects) {
		obj->cleanup();
	}
}