#pragma once

#include "Common.h"
#include "VulkanDevice.h"

#include <random>

/**
 *  A class for implementing specific parts of a GPU particle system.
 */
class ParticleSystem {
public:
	ParticleSystem() {};
	ParticleSystem(VulkanDevice vulkanDevice, int particleCount) : m_vulkanDevice(vulkanDevice), m_particleCount(particleCount) {
		m_device = vulkanDevice.getVkDevice();

        createStorageBuffer();
    };

    void cleanup();

    std::vector<VkBuffer> getStorageBuffers() const { return m_shaderStorageBuffers; }
    int getParticleCount() const { return m_particleCount; }

private:
	VulkanDevice m_vulkanDevice;
	VkDevice m_device;

    std::vector<VkBuffer> m_shaderStorageBuffers;
    std::vector<VkDeviceMemory> m_shaderStorageBuffersMemory;
	int m_particleCount;

	void createStorageBuffer();


};