#pragma once
#include "Common.h"
#include "spline.h"

/**
 *  A class implementing a path (spline interpolated keypoints).
 */
class Path {
public:
	Path();
	~Path();
	void loadKeyframes(std::string filepath);
	glm::vec3 getPosition(float dt);
	glm::quat getRotation(float dt, glm::vec3 forward);
private:

	tk::spline x;
	tk::spline y;
	tk::spline z;

};