#version 450

layout(binding = 0) uniform UniformBufferObject {
    mat4 model;
    mat4 view;
    mat4 proj;
} ubo;

layout(push_constant) uniform PerViewPush {
	mat4 vdirection;
} push;


layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec3 inNormal;

layout(location = 0) out vec3 fragUVW;
layout(location = 1) out vec3 fragNormal;
layout(location = 5) out vec3 outWorldPos;

void main() {
    gl_Position = ubo.proj * ubo.view * push.vdirection * vec4(inPosition, 1.0);
    fragUVW = inPosition;
	fragUVW.xy *= -1.0;
	fragNormal = inNormal;
	
	vec3 worldDir = (inverse(ubo.view) * vec4(inPosition, 0.0)).xyz;
    outWorldPos = normalize(worldDir);
}