#version 450

layout(binding = 0) uniform UniformBufferObject {
    mat4 model;
    mat4 view;
    mat4 proj;
} ubo;

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec3 inNormal;

layout(location = 0) out vec3 fragUVW;
layout(location = 1) out vec3 fragNormal;
layout(location = 5) out vec3 outWorldPos;
layout(location = 8) out vec3 reflectionDir;
layout(location = 9) out vec3 boxMin;
layout(location = 10) out vec3 boxMax;

void main() {
    gl_Position = ubo.proj * ubo.view * ubo.model * vec4(inPosition, 1.0);
    fragUVW = inPosition;
	
	mat3 normalMatrix = transpose(inverse(mat3(ubo.model)));
	//fragNormal = normalize(normalMatrix * inNormal);
	fragNormal = normalize(mat3(ubo.model) * inNormal);

	vec4 position_world_space = ubo.model * vec4(inPosition, 1.0);
    outWorldPos = position_world_space.xyz; 

	vec4 boxMinWS = ubo.model * vec4(-20.0f, -20.0f, -20.0f, 1.0f);
	vec4 boxMaxWS = ubo.model * vec4(20.0f, 20.0f, 20.0f, 1.0f);
	boxMin = boxMinWS.xyz;
	boxMax = boxMaxWS.xyz;
}