#version 450

layout(binding = 1) uniform sampler2D texSampler;
layout(binding = 2) uniform sampler2D normalSampler;

layout(binding = 3) uniform MaterialUniformBufferObject {
    vec3 coefficients; // x = ambient, y = diffuse, z = specular
    float metallic;
    float roughness;
	float specularAlpha;
} mubo;

layout(location = 0) in vec3 fragColor;
layout(location = 1) in vec2 fragTexCoord;
layout(location = 2) in mat3 TBN;
layout(location = 5) in vec3 inWorldPos;

layout(location = 0) out vec4 outAlbedo;
layout(location = 1) out vec4 outNormal;
layout(location = 2) out vec4 outCoefficients;
layout(location = 3) out vec4 outMaterial;
layout(location = 4) out vec4 outWorldPos;

void main() {
	vec3 albedo = texture(texSampler, fragTexCoord).rgb;
	//vec3 normal = texture(normalSampler, fragTexCoord).rgb * 2.0 - 1.0;
	vec3 normal = texture(normalSampler, fragTexCoord).rgb;
    normal = normalize(TBN * normal);

	float test = mubo.metallic;

	outAlbedo = vec4(albedo, 1.0f);
	outNormal = vec4(normal, 1.0f);
	outCoefficients = vec4(mubo.coefficients, 1.0f);
	outMaterial = vec4(mubo.metallic, mubo.roughness, mubo.specularAlpha, 1.0f);
	outWorldPos = vec4(inWorldPos, 1.0f);
}