#version 450

layout(binding = 1) uniform sampler2D texSampler;
layout(binding = 2) uniform sampler2D normalSampler;

layout(location = 0) in vec3 fragColor;
layout(location = 1) in vec2 fragTexCoord;
layout(location = 2) in mat3 TBN;
layout(location =  8) in vec3 fragPositionWS;

layout(location = 0) out vec4 outAlbedo;

void main() {
    vec3 normal = texture(normalSampler, fragTexCoord).rgb * 2.0 - 1.0;
    normal = normalize(TBN * normal);
    
    // Simple directional light
    vec3 lightDir = normalize(vec3(0.0, -1.0, 0.0));  
    float diff = max(dot(normal, lightDir), 0.0);

    // Sample diffuse albedo
    vec3 albedo = texture(texSampler, fragTexCoord).rgb;  

    // Combine diffuse lighting with albedo
    vec3 color = albedo * diff;

	outAlbedo = vec4(color, 1.0f);

}