#version 450

layout(binding = 0) uniform UniformBufferObject {
    mat4 model;
    mat4 view;
    mat4 proj;
	float tilingFactor;
} ubo;

layout(push_constant) uniform PerViewPush {
	mat4 vdirection;
} push;

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec3 inNormal;
layout(location = 2) in vec2 inTexCoord;
layout(location = 3) in vec3 inTangent;
layout(location = 4) in vec3 inBitangent;

layout(location = 0) out vec3 fragColor;
layout(location = 1) out vec2 fragTexCoord;
layout(location = 2) out mat3 TBN;
layout(location = 8) out vec3 fragPosWS;

void main() {
    gl_Position = ubo.proj * ubo.view * push.vdirection * ubo.model * vec4(inPosition, 1.0);
    fragColor = inNormal;
    fragTexCoord = inTexCoord * ubo.tilingFactor;

    mat3 normalMatrix = transpose(inverse(mat3(ubo.model)));
    vec3 T = normalize(normalMatrix * inTangent);
    vec3 B = normalize(normalMatrix * inBitangent);
    vec3 N = normalize(normalMatrix * inNormal);
    TBN = mat3(T, B, N);
	
	fragPosWS = (ubo.model * vec4(inPosition, 1.0f)).xyz;
}