#version 450

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec4 inColor;
layout(location = 2) in float inAngle;
layout(location = 3) in float inLifetime;
layout(location = 4) in vec3 inRandomness;
layout(location = 5) in float inMaxLifetime;

layout (binding = 0) uniform UniformBufferObject {
	mat4 model;
    mat4 view;
    mat4 proj;
} ubo;

layout(location = 0) out vec4 fragColor;
layout(location = 1) out float outLifetime;
layout(location = 2) out float outMaxLifetime;


void main() {
    gl_Position = vec4(inPosition, 1.0);
    fragColor = vec4(inColor.rgb, (inMaxLifetime - inLifetime) / inMaxLifetime);
	outLifetime = inLifetime;
	outMaxLifetime = inMaxLifetime;
}